using System.Security.Cryptography;
using System.Text;

namespace FitConnect;

/// <summary>
///     This class contains all security related methods that can be changed due to future
///     security issues or decisions from the BSI.
/// </summary>
internal static class SecuritySpecification {
    public const int MaxCallbackAge = 5;

    public static byte[] CalculateCallbackHmac(string callbackSecret, long timestamp, string body) {
        return new HMACSHA512(Encoding.UTF8.GetBytes(callbackSecret))
            .ComputeHash(Encoding.UTF8.GetBytes($"{timestamp}.{body}"));
    }
}
